/* eslint-disable camelcase */
const fs = require('fs-extra')
const path = require('path')
const UserModel = require('../../../models/UserModel')
const jwt = require('jsonwebtoken')

const setProfileImage = async (req, res, next) => {
  try {
    const token = req.header('Authorization').split(' ')[1]
    if (!token) return res.status(401).send('Access Denied')
    const { mobile } = req.body
    const { profile_image } = req.files
    if (!mobile) {
      return res.status(422).json({
        error: true,
        message: 'اطلاعات ارسالی اشتباه است'
      })
    }
    const decodedToken = jwt.verify(token, process.env.APP_SECRET)
    const user = await UserModel.findById(decodedToken.id)
    if (!user) {
      return res.status(404).json({
        error: true,
        message: 'کاربری با این شماره موبایل یافت نشد'
      })
    }
    // بررسی آیا فایل آپلود شده است
    if (!profile_image) {
      return res.status(400).json({
        error: true,
        message: 'لطفاً عکس پروفایل را انتخاب کنید'
      })
    }

    // ذخیره فایل عکس پروفایل
    const uploadDir = path.join(__dirname, '../../../../storage/profiles')
    if (!fs.existsSync(uploadDir)) {
      fs.mkdirSync(uploadDir, { recursive: true })
    }
    const uniqueFileName = `${user.user_name}-${Date.now()}${path.extname(profile_image.name)}`
    const filePath = path.join(uploadDir, uniqueFileName)

    await fs.move(profile_image.path, filePath)
    // ذخیره مسیر فایل در دیتابیس
    user.profile_image = `/profiles/${uniqueFileName}`
    await user.save()

    return res.json({
      message: 'عکس پروفایل با موفقیت ذخیره شد',
      profile_image: user.profile_image
    })
  } catch (error) {
    next(error)
  }
}

const updateProfileImage = async (req, res, next) => {
  try {
    const token = req.header('Authorization').split(' ')[1]
    if (!token) return res.status(401).send('Access Denied')
    const decodedToken = jwt.verify(token, process.env.APP_SECRET)
    const userId = decodedToken.id
    const { profile_image } = req.files

    if (!profile_image) {
      return res.status(422).json({
        error: true,
        message: 'اطلاعات ارسالی اشتباه است'
      })
    }

    const user = await UserModel.findById(userId)

    if (!user) {
      return res.status(404).json({
        error: true,
        message: 'کاربری با این شماره موبایل یافت نشد'
      })
    }

    const uploadDir = path.join(__dirname, '../../../../storage/profiles')

    if (!fs.existsSync(uploadDir)) {
      fs.mkdirSync(uploadDir, { recursive: true })
    }

    const uniqueFileName = `${user.user_name}-${Date.now()}${path.extname(profile_image.name)}`
    const filePath = path.join(uploadDir, uniqueFileName)

    await fs.move(profile_image.path, filePath)

    user.profile_image = `/profiles/${uniqueFileName}`
    await user.save()

    return res.json({
      message: 'عکس پروفایل با موفقیت به‌روزرسانی شد',
      profile_image: user.profile_image
    })
  } catch (error) {
    next(error)
  }
}
module.exports = {
  setProfileImage, updateProfileImage
}
